package com.mutare.gistt;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.List;

import org.apache.commons.io.IOUtils;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import com.roobroo.TaskService;
import com.google.gson.Gson;
import com.avaya.app.entity.Instance;
import com.avaya.app.entity.NodeInstance;
import com.roobroo.bpm.model.BpmNode;
import com.roobroo.designer.data.Category;
import com.roobroo.designer.data.MType;
import java.lang.reflect.Method;
import java.util.ArrayList;

public class MyService implements TaskService {

	public MyService() {

	}

        @Override
        public String getName() {
                return "Your tasks";
        }

	@Override
	public Category[] getTaskCategories() {
		BufferedReader in = null;
		Gson gson = new Gson();
		try {
			in = new BufferedReader(new StringReader(IOUtils.toString(
					this.getClass().getResourceAsStream("/tasks.json"), "UTF-8")));
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		return gson.fromJson(in, Category[].class);
	}

	@Override
	public BpmNode getModel(String model, String name, String id) {
		try {
			return (BpmNode) Class.forName(model).getConstructor(new Class[] { String.class, String.class })
					.newInstance(name, id);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	public NodeInstance getExecutor(Instance instance, BpmNode node, String whatYouWantFromWhatever) {
		Class c = null;
		try {
			c = Class.forName(whatYouWantFromWhatever);
			Constructor con = c.getConstructor(new Class[] { Instance.class, BpmNode.class });
			return NodeInstance.class.cast(con.newInstance(new Object[] { instance, node }));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public byte[] getResource(String resourceName) {
		try {
			return IOUtils.toByteArray(this.getClass().getResourceAsStream(resourceName));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@Override
	public ArrayList<String> getFillerData(String modelName, String filler, String strParam) {
		ArrayList<String> rList = new ArrayList<String>();
		Class cls = null;
		Object ob = null;
		Object rObj = null;
		Class noParam[] = {};

		try {
			cls = Class.forName(modelName);
			if (filler.contains(".")) {
				String filler1 = filler.substring(0, filler.indexOf('.'));
				Method method1 = cls.getDeclaredMethod(filler1, noParam);
				ob = method1.invoke(null);
				String filler2 = filler.substring(filler.indexOf('.') + 1, filler.length());
				if (strParam == null || strParam.equals("")) {
					Method method2 = cls.getDeclaredMethod(filler2, noParam);
					rObj = method2.invoke(ob);
				} else {
					Method method2 = cls.getDeclaredMethod(filler2, String.class);
					rObj = method2.invoke(ob, strParam);
				}
			} else {
				ob = cls.newInstance();
				Method method1 = cls.getDeclaredMethod(filler, noParam);
				rObj = method1.invoke(ob);
			}
			if (rObj == null) {
				return null;
			} else {
				return (ArrayList<String>) rObj;
			}

		} catch (Exception e) {
			throw new RuntimeException(e);
		}

	}

	@Override
	public String executeClicker(String clickerModel, String clickerFunc, String strParam) {
		Class<?> cls = null;
		Object ob = null;
		Object rStr = null;

		try {
			cls = Class.forName(clickerModel);
			ob = cls.newInstance();
			Method method1;
			method1 = cls.getDeclaredMethod(clickerFunc, String.class);
			if (method1 != null) {
				rStr = method1.invoke(ob, strParam);
				return (String) rStr;
			}

		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		return null;
	}
}
